/* -*- mode: c; coding: sjis-dos; -*- 
 * Copyright 1992-1997, By T.Furukawa
 *
 * $Id: defread.c,v 1.4 1999/12/28 18:54:02 tfuruka1 Exp $
 * $Log: defread.c,v $
 * Revision 1.4  1999/12/28 18:54:02  tfuruka1
 * I舂ɂARpCG[̂܂܃`FbNCĂ܂̂ŏCB
 *
 * Revision 1.3  1999/12/28 18:50:50  tfuruka1
 * ϊΏە1oCg
 *
 * Revision 1.2  1997/04/26 06:04:14  furukawa
 * Stdin/out T|[g
 *
 * Revision 1.1  1997/04/18  14:19:38  furukawa
 * Initial revision
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "zen2han.h"

extern PCONVERT_TBL Wtbl;
extern int StdOut;

static void ErrorMessage(char *FileName, int Line, char *Buf, char *Msg)
{
    fprintf(stderr, "%s(%d): %s <%s>\n", FileName, Line, Buf, Msg);
    fflush(stderr);
}

void DefRead(char *DefFile)
{
    PCONVERT_TBL Current;
    unsigned char *Buf, *p0, *p1, *p2;
    int Sep, Line;
    FILE *fp;

    if (!StdOut) printf("`t@C͒(%s)\n", DefFile);

    if (NULL == (Buf = (unsigned char *)malloc(1024 * 2))) {
        fprintf(stderr, "mۂɎs܂\n");
        exit(1);
    }
    if (NULL == (fp = fopen(DefFile, "rt"))) {
        perror(DefFile);
        exit(1);
    }

    Line = 0;
    while (fgets((char *)Buf, 1024, fp)) {
        Line++;
        if (' ' == (int)*Buf || '\t' == (int)*Buf || '\r' == (int)*Buf ||
            '\n' == (int)*Buf || '#' == (int)*Buf) continue;
        Sep = (int)*Buf;
        strcpy((char *)Buf + 1024, (char *)Buf);
        if (NULL == (p0 = (unsigned char *)strchr((char *)Buf, Sep))){
            ErrorMessage(DefFile, Line, (char *)Buf, "\͏o܂");
            continue;
        }
        if (NULL == (p1 = (unsigned char *)strchr((char *)p0 + 1, Sep))) {
            ErrorMessage(DefFile, Line, (char *)Buf, "\͏o܂");
            continue;
        }   
        if (NULL == (p2 = (unsigned char *)strchr((char *)p1 + 1, Sep))) {
            ErrorMessage(DefFile, Line, (char *)Buf, "\͏o܂");
            continue;
        }   
        *p0 = *p1 = *p2 = '\0';
        p0++;
        p1++;
        if (2 < strlen((char *)p0)) {
            ErrorMessage(DefFile, Line, (char *)Buf + 1024,
                         "ϊΏە͈ꕶ̂ݎwo܂");
            continue;
        }
        if (0 == strlen((char *)p0)) {
            ErrorMessage(DefFile, Line, (char *)Buf + 1024,
                         "ϊΏەw肳Ă܂");
            continue;
        }
#if 0
        if (!isKanji((int)*p0)) {
            ErrorMessage(DefFile, Line, (char *)Buf + 1024,
                         "ϊΏە͑SpłȂ΂Ȃ܂");
            continue;
        }
#endif
        if (39 < strlen((char *)p1)) {
            ErrorMessage(DefFile, Line, (char *)Buf + 1024,
                         "ϊ39zĂ܂B");
            continue;
        }
            
        if (!Wtbl) {
            if (NULL == (Current = Wtbl = (PCONVERT_TBL)
                         malloc(sizeof(CONVERT_TBL)))) {
                fprintf(stderr, "܂\n");
                exit(1);
            }
        } else {
            if (NULL == (Current->Next = (PCONVERT_TBL)
                         malloc(sizeof(CONVERT_TBL)))) {
                fprintf(stderr, "sł\n");
                exit(1);
            }
            Current = Current->Next;
        }
        Current->Next = NULL;
        Current->to[0] = '\0';
        strcpy(Current->from, (char *)p0);
        if ('\0' != *p1) strcpy(Current->to, (char *)p1);
        if (!StdOut)
            printf("(u%svu%sv)", Current->from, Current->to[0] ?
                   Current->to : "[폜]");
        fflush(stdout);
    }
    if (!StdOut) printf("`t@C͏I(%s)\n", DefFile);
    fclose(fp);
}
