/* -*- mode: C; coding: sjis-dos; -*-
$Id: wild.c,v 1.2 1999/12/28 18:50:08 tfuruka1 Exp $
$Log: wild.c,v $
Revision 1.2  1999/12/28 18:50:08  tfuruka1
ɕύXȂB[hwb_ɃR[fBOǉB

Revision 1.1  1997/04/18 14:19:57  furukawa
Initial revision


MS-DOS  UNIX CNȃChJ[hWJ郉CułBƂ
쐬͎̂(tfuruka1@vdnet.or.jp, HGA00616@niftyserve.or.jp,
tfuruka1@nsw.co.jp) ł͂܂BL肩ł͂Ȃ̂ł, 1990N
O C}KW̕t^ɂĂ PDS łB̃\[XɎ 
WIN32  djgpp ɑΉ̂łB܂AUNIX ɉĂ WIN32,
MS-DOS, djgpp Ƃ̃t@C̋plēlȓ悤ɂ܂
B(ہAUNIX ̏ꍇ͉sĂ܂B󂯎
܂܃^[悤ɂȂĂ܂B)
*/
#if defined(MSDOS) || defined(WIN32) || defined(DJGPP)

typedef unsigned long ULONG;
typedef unsigned short USHORT;

#if defined(WIN32)
#       include <windows.h>
#       define  far
#elif defined(DJGPP)
#       include <dir.h>
#       define far
#elif defined(MSDOS)
#       include <dos.h>
#else
may be -DWIN32 -DMSDOS -DDJGPP
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <io.h>
#include <string.h>
    
#define iskanji(c) (((0x81<=(unsigned char)(*c) &&      \
                      (unsigned char)(*c)<=0x9f) ||   \
                     (0xe0<=(unsigned char)(*c) &&      \
                      (unsigned char)(*c)<=0xfc)) &&  \
                    c[1])

#ifndef WIN32
typedef enum {FALSE=0, TRUE=1} boolean;
#endif

/* Record to hold file status */
typedef struct {
#ifndef WIN32
    unsigned char attr;     /* File attribute */
#else
    DWORD attr;
#endif
    char *name;             /* Filename */
} filetype;

/* Registers for general purpose */
#if !defined(WIN32) && !defined(DJGPP)
    union REGS inregs;
    union REGS outregs;
    struct SREGS sregs;
#endif

#define ESC_CHR '\''    /* Escape prefix */
#define PATH_SEP '\\'   /* Path separator */

#define PATHNAMELENGTH 128 /* Maximum path name length */
#define MAXFILENUMBER 200  /* Maximum filenumber for one directory */
#define INITFILENUMBER 40
#ifndef WIN32
#       define MAX_PATH 13
#endif

int _wildcard_nomatch= FALSE;
int _wildcard_exist  = FALSE;

/*
 *
 *      Miscellaneous subroutines.
 *
 */

static void fatal(char *s) {fputs(s,stderr);putc('\n',stderr);exit(1);}
static void *wmalloc(unsigned n)
{
    void *m;
    /* void *malloc(unsigned);*/
    if ((m=malloc(n))==0) fatal("Malloc heap exhausted");
    return m;
}
static void *wrealloc(void *old,unsigned n)
{
    void *r;
    /* void *realloc(void *,unsigned);*/
    if ((r=realloc(old,n))==0) fatal("Memory exhausted");
    return r;
}
/*
  Convert lower character to UPPER character.
  */
static void to_CAPITAL(unsigned char *s)
{
    while (*s) {
        if (iskanji(s)) if(s[1]) s+=2; else s++;
        else {
            *s=toupper(*s);
            s++;
        }
    }
}

/*
 *      Wildcard compilation, matching.
 *
 */

/* Internal representation of wildcard strings. */
#define ANYSTRING 1     /* '*' */
#define ANYCHAR   2     /* '?' */
#define LBRACKET  3     /* [....] */
#define NOT_CHARSET 4   /* [^....] */
#define RANGE     5     /* [ .. `-'..] */

#define isspecial(c) ((c)<0x20)
#define ispathdelim(c) ((c==PATH_SEP)||(c=='/'))

/*
  Check if 's', which is the internal representation of wildcard string,
  contains metacharacter.
  */
static boolean contains_metacharacter_p(unsigned char *s)
{
    while (*s) {
        if (isspecial(*s))  return TRUE;
        s++;
    }
    return FALSE;
}


/*
  Scan Escaped sequence and return the value of the sequence.
  'c' are changed by this routine 
  */

#define hex_to_int(b) if (b>='a') b=b-'a'+10;   \
else if (b>='A') b=b-'A'+10;         \
else b=b-'0'
    static unsigned char *escape_char(unsigned char const *s,unsigned char *c)
{
    if (! *(s+1)) goto normal;
    else if (isxdigit(*(s+1)) && isxdigit(*(s+2))) { /* as "'ab" */
        unsigned char b;
        int x;
        b=*(s+1);hex_to_int(b);
        x=b*16;
        b=*(s+2);hex_to_int(b);
        x+=b;
        if ((unsigned char)(x)<0x20) goto normal;
        *c=(unsigned char)x;return (unsigned char *)(s+3);
    } else {        /* as "'*" */
    normal:          *c=*(s+1);
        return (unsigned char *)(s+2);
    }
}

/* Convert wildcard filename to internal format.
   `s' is a source string,
   `buf' is a destination string.
   */
static void make_internal(unsigned char const *s,unsigned char *buf)
{
    unsigned char c;
    
    while (*s) {
        if (*s<' ') fatal("Invalid character in string");
        if (iskanji(s)) {
            *buf++=*s++;
            if (*s) *buf++=*s++;
            continue;
        }
        switch(*s) {
        case '*':s++;*buf++=ANYSTRING;break;
        case '?':s++;*buf++=ANYCHAR;break;
        case '[':{
            char *temp;int count=0;
            s++;
            if (*s=='^') {*buf++=NOT_CHARSET;s++;}
            else         *buf++=LBRACKET;
            
            temp=buf++; /* keep the position in `temp' */
            
            while (*s!=']') {
                if(iskanji(s))
                    fatal("kanji cannot be used in [..]");
                switch(*s) {
                case '-':
                    if ((*(s-1)=='-')||(*(s-1)=='[')||(*(s+1)==']'))
                        goto others;
                    *buf= *(buf-1);
                    *(buf-1)=RANGE;
                    s++;buf++;
                    break;
                case '\0':goto seterr; /* error */
                case ESC_CHR:s=escape_char(s,&c);
                    *buf++=c;
                    break;
                default:
                others:                 *buf++=*s++;
                }
                count++;
            }
        seterr:         s++;*temp=(unsigned char)(count);
            /* [ab-d] -> LBRACKET,4,a,RANGE,b,d */
        }
            break;
        case ESC_CHR:
            s=escape_char(s,&c);
            *buf++=c;
            break;
        case '/':s++;*buf++=PATH_SEP;break;
        default:
            *buf++=*s++;
        }
    }
    *buf='\0';
}


/*
  
  Check whether two string `ref',`s' match.
  `ref' is an ordinal array of character,
  `s' is an internal representation of wildcard .
  
  */
static boolean string_match(unsigned char const *ref,unsigned char const *s)
{
    boolean not_set=FALSE;
    while (*s) {
        switch(*s) {
        case ANYCHAR:s++;
            if(iskanji(ref)) ref+=2;
            else ref++;
            break;
        case ANYSTRING: {
            s++;
            while(*ref) {
                if (string_match(ref,s)) return TRUE;
                if (iskanji(ref)) ref++;
                ref++;
            }
            if (string_match("", s)) return TRUE;
            return FALSE;
        }
        case NOT_CHARSET:not_set=TRUE;
        case LBRACKET:
        {
            int cnt;
            unsigned char const *next;
            s++;
            cnt=(int)(*(s++));
            next=s+cnt;
            if (!iskanji(ref))
                for (;cnt>0;cnt--) {
                    switch(*s) {
                    case RANGE:s++;cnt-=5;
                        if ((*ref >= *s)&&(*ref <= *(s+1))) goto IOK;
                        break;
                    default:
                        if (*s<0x20) fatal("in set");
                        if (*s++ == *ref)
                        {
                        IOK:                            if (not_set) return FALSE;
                            ref++;
                            s=next;
                            goto OK;
                        }
                        break;
                    }
                }
            if (not_set) {ref++;s=next;goto OK;}
            else return FALSE;
        }
        case '\0':return FALSE;
        default:if (*s<32) fatal("internal");
            if (iskanji(s)) {
                if (*s++ != *ref++) return FALSE;
                if (*s++ != *ref++) return FALSE;
            } else {
                if (*s++ != toupper(*ref)) return FALSE;
                ++ref;
            }
            break;
        }
    OK:;
    }
    if (*ref) return FALSE;
    return TRUE;
}


/*
  Expand pathname.
  This routine is functionally same as 
  'sprintf(buf,"%s\\%s",base,dir);'
  except that the length of the string is checked, to avoid stack 
  violation.
  */
static void expand_pathname(char *buf,char const *base,char const *dir)
{
    char *b=buf;
    while (*base) {
        if (b-buf>=PATHNAMELENGTH-2) goto error;
        *b++=*base++;
    }
    *b++=PATH_SEP;
    while (*dir) {
        if (b-buf>=PATHNAMELENGTH-2)
        error:          fatal("Path name length exceed");
        *b++=*dir++;
    }
    *b='\0';
}


/*
 *
 *      Reading directory contents.
 *
 */
static char *bufptr;    /* store filenames */
static int filenumber;  /* number of files read from directory */
#if defined(WIN32)
    WIN32_FIND_DATA dta;
#elif defined(DJGPP)
    struct ffblk dta;
#else
    static union {          /* DTA address */
        unsigned char far *x;
        struct {int l,h;} i;
    } dta;
#endif

/*
  Copy contents of DTA to the buffer.
  */

static void copy_file_status_to_buffer(filetype *f)
{
#if defined(WIN32)
    char *fn = dta.cFileName;
#elif defined(DJGPP)
    char *fn = dta.ff_name;
#else
    char far *fn=(dta.x+0x1e);
#endif

    if (filenumber++ >= MAXFILENUMBER) fatal("Too many files in directory");
    f->name=bufptr;
    while (*fn) {
        while (*fn==' ') fn++;
        *bufptr++= *fn++;
    }
    *bufptr++= '\0';
#if defined(WIN32)
    fn = dta.cFileName;
    f->attr = dta.dwFileAttributes;
#elif defined(DJGPP)
    fn = dta.ff_name;
    f->attr = dta.ff_attrib;
#else
    fn=(dta.x+0x15);
    f->attr= *((unsigned char far*)fn);
#endif
    
}
/*
  
  Read directory and store file names to filenameptr[].
  `pathname' is a directory name.
  (same as used in `cat')
  `buf' is buffer to store file names.
  
  */
static void read_directory(char const *pathname,char *buf,filetype *filbuf)
{
    char temp[PATHNAMELENGTH];
    char far *farpathname;
#ifdef WIN32
    HANDLE FindHandle;
#endif
    
#if !defined(WIN32) && !defined(DJGPP)
    /* Get DTA address */
    inregs.h.ah=0x2f;
    intdosx(&inregs,&outregs,&sregs);
    dta.i.h=sregs.es;
    dta.i.l=outregs.x.bx;
#endif
    expand_pathname(temp,pathname,"*.*"); /* search all file */
    farpathname=(char far*)temp;


#if defined(DJGPP)
    if (!findfirst(farpathname, &dta, 0x3f)) {
      filbuf[0].name = (char *)0;
      return;
    }
#elif !defined(WIN32)
    inregs.x.dx=FP_OFF(farpathname);
    sregs.ds=FP_SEG(farpathname);
    inregs.h.ah=0x4e;
    inregs.x.cx=0x35;
    intdosx(&inregs,&outregs,&sregs);
    
    /* can't find file in directory */
    if (outregs.x.cflag) {filbuf[0].name=(char*)0;return;}
#else
    if (INVALID_HANDLE_VALUE == (FindHandle = 
                                 FindFirstFile(farpathname, &dta))) {
        filbuf[0].name = (char *)0;
        return;
    }
#endif
    filenumber=0;
    bufptr=buf;
    
    copy_file_status_to_buffer(filbuf);
    filbuf++;
#if defined(DJGPP)
    for (;;) {
      if (!findnext(&dta)) break;
      copy_file_status_to_buffer(filbuf);
      filbuf++;
    }
#elif !defined(WIN32)
    inregs.h.ah=0x4f;
    for (;;) {
        intdos(&inregs,&outregs);
        if (outregs.x.cflag) break;
        copy_file_status_to_buffer(filbuf);
        filbuf++;
    }
#else
    for (;;) {
        if (!FindNextFile(FindHandle, &dta)) {
            FindClose(FindHandle);
            break;
        }
        copy_file_status_to_buffer(filbuf);
        filbuf++;
    }
#endif
    filbuf->name=(char*)0;
}

/*
 *      Store filename strings.
 *
 */
static int current,     /* Current number of files that is expanded. */
    sz_files;    /* Malloc size. */
static char **files;    /* Final Returning array. */

/*
  Set filename string 's' to the final returning variable 'char **files.'
  */
static void set_final_filename(char *s)
{
    char *d,*sp=s;
    if (current >= sz_files-1)
        /*             ^^^^^^^^^^ This is not the bug.
                       The last element of 'files' is reserved for NULL terminator.
                       */
    {
        sz_files*=2;
        files = (char**)wrealloc(files, sz_files*sizeof(char*));
    }
    d=files[current]=wmalloc(strlen(s)+1);
    
    while (*s) {
        /* Skip '.\' in string */
        if ((sp==s || *(s-1)==PATH_SEP) && *s=='.' && *(s+1)==PATH_SEP)
            s+=2;
        else *d++=*s++;
    }
    *d='\0';
    ++current;
}
/*
  Store string 's' without any processing.
  */
static void set_final_string(char *s)
{
    char *d,*sp=s;
    if (current >= sz_files-1)
        files = (char**)wrealloc(files, (sz_files*=2)*sizeof(char*));
    
    d=files[current]=wmalloc(strlen(s)+1);
    strcpy(d,s);
    ++current;
}


/*
 *
 *      Main routine of wildcard expansion.
 *
 *      subdirectory    : Directory to start searching.
 *      wildcard        : Internal wildcard pattern to match.
 */

static void search_dir(char const *subdirectory,char const *wildcard)
{
    char new_subdir[PATHNAMELENGTH];
    char head[PATHNAMELENGTH];
    char const *rest;
    char next[PATHNAMELENGTH];
    char filenamebuf[MAX_PATH * MAXFILENUMBER];
    filetype filedata[MAXFILENUMBER];
    int i;
    
 start:
    
    /* Split wildcards into two part, Head and Rest. */
    for (i=0;wildcard[i]!=PATH_SEP;i++) {
        head[i]=wildcard[i];
        if (wildcard[i]=='\0') {
            rest=&wildcard[i];
            goto finalcheck;
        }
        if (iskanji((&wildcard[i]))) {i++; head[i]=wildcard[i];}
    }
    head[i]='\0';
    rest=&wildcard[i+1];
    
    /* If 'head' does not include metacharacter,
       then skip this level and go next.     */
    if (!contains_metacharacter_p(head) && *rest) {
        expand_pathname(new_subdir,subdirectory,head);
        subdirectory=new_subdir;
        wildcard=rest;
        goto start;
        /* search_dir(next,rest);
           return; */
    }
    
 finalcheck:
    
    read_directory(subdirectory,filenamebuf,filedata);
    for (i=0;filedata[i].name;i++)
        /* When filename is "." or "..", then we skip them.
           Since DOS doesn't permit filename that has '.'
           at the top like ".cshrc", we only have to
           check whether the top of the name is '.', to
           detect "." , ".." .             */
        if (*(filedata[i].name)!='.')
            if (string_match(filedata[i].name,head)) {
                expand_pathname(next,subdirectory,filedata[i].name);
#if defined(DJGPP)
		if (*rest == '\0') {
		  set_final_filename(next);
		}
		else if (filedata[i].attr & FA_DIREC) {
		  search_dir(next, rest);
		}
		
#elif !defined(WIN32)
                if (*rest=='\0') {
                    set_final_filename(next);
                }
                else if (filedata[i].attr & 0x10) {
                    search_dir(next,rest);
                }
#else
                if (*rest=='\0') {
                    set_final_filename(next);
                }
                else if (filedata[i].attr & FILE_ATTRIBUTE_DIRECTORY) {
                    search_dir(next,rest);
                }
#endif
            }
}

/*
  
  Expand wildcards, after '{..}' is expanded.
  
  str     :String to expand, which may contain wildcard patterns.
  */
static void expand(char *str)
{
    unsigned char s[BUFSIZ];
    int old_current=current;
    make_internal(str,s);
    /* If 's' does not contain metacharcters, return 's' itself. */
    if (!contains_metacharacter_p(s)) {
        set_final_string(s);
        files[current]=(char*)0;
        return;
    }
    _wildcard_exist = TRUE;
    
    /* Change all lower characters to UPPER characters to make matching
       easy. */
    to_CAPITAL(s);
    
    if (isalpha(*s) && *(s+1)==':') {
        /* Device name at the top of the pathname. */
        unsigned char dev_s[6];
        dev_s[0]=*s;dev_s[1]=*(s+1);
        if (*(s+2)==PATH_SEP) {
            /* Absolute pathname, as 'a:\foo'. */
            dev_s[2]='\0';
            search_dir(dev_s,s+3);
        } else {
            /* Relative pathname, as 'b:bar'. */
            dev_s[2]='.';dev_s[3]='\0';
            search_dir(dev_s,s+2);
        }
    } else if (*s==PATH_SEP) {
        search_dir("",s+1);
    } else {
        search_dir(".",s);
    }
    
    /* Mark end of the array */
    files[current]=(char*)0;
    
    /* set _wildcard_nomatch */
    if (old_current >= current)
        _wildcard_nomatch = TRUE;
}

/*
 *
 *      Brace '{}' expansion.
 *      Brace is expanded before wildcard pattern is expanded.
 *
 */

#define BRACE_EXPAND_INIT 20
static int sz_wildstring;       /* Malloc size */
static char **wildstring;       /* Store strings after {} 
                                 * expansion */
static int wildidx;             /* Last element of the wildstring. */

/*
 *      Add string to the wildstring.
 */
static void set_intermediate_filename(char *str)
{
    if (wildidx >= sz_wildstring)
        wildstring=wrealloc(wildstring,(sz_wildstring*=2)*sizeof(char*));
    wildstring[wildidx]=wmalloc(strlen(str)+1);
    strcpy(wildstring[wildidx],str);
    wildidx++;
}

/*
  Expand brace main routine.
  */
static void expand_brace(char *ref)
{
    char *ptr,*temp,*bufptr;
    char *firstlbrace,*matchingrbrace;
    int num = 0;
    char buf[BUFSIZ];
    
    
    /*
     * Find first '{' in the string and set 'firstlbrace'.
     */
    ptr=ref;
    for (ptr=ref;*ptr!='{';ptr++) {
        if (iskanji(ptr)) ptr++; else
            if (*ptr==ESC_CHR && *(ptr+1)=='{') ptr++;
        if (*ptr=='\0') {
            /* If there is no '{', then store the string and return */
            set_intermediate_filename(ref);
            return;
        }
    }
    firstlbrace=ptr++;
    temp=ptr;
    
    /*
     * Find matching '}' in the string and set 'matchingrbrace'.
     */
    while (*temp!='}') {
        if (*temp=='\0')
            fatal("unmatched '}'");
        if (iskanji(temp)) temp++; else
            if (*temp==ESC_CHR && (*(temp+1)=='}' || *(temp+1)==',')) temp++;
        temp++;
    }
    matchingrbrace=temp+1;
    
    /*
     * Expand each applicants in '{..}' and call 'expand_brace'
     *      recursively
     */
    while (*ptr!='}') {
        bufptr=buf;
        for (temp=ref;temp<firstlbrace;)
            *bufptr++ = *temp++;
        while (*ptr!=',' && *ptr!='}') {
            if (iskanji(ptr)) *bufptr++=*ptr++; else
                if (*ptr==ESC_CHR && (*(ptr+1)=='}' || *(ptr+1)==','))
                    *bufptr++=*ptr++;
            *bufptr++ = *ptr++;
        }
        strcpy(bufptr,matchingrbrace);
        expand_brace(buf);
        if (*ptr==',') ptr++;
    }
}

char **expand_wildcards(char **str)
{
    int i;
    
    /* Allocate initial space for brace expansion */
    wildidx=0;
    sz_wildstring=BRACE_EXPAND_INIT;
    wildstring=wmalloc(sizeof(char*)*BRACE_EXPAND_INIT);
    
    /* Expand '{..}' */
    
    while(*str) {
        if (strlen(*str) >= BUFSIZ) fatal("pathname too long");
        expand_brace(*str);
        str++;
    }
    
    /* Allocate initial space for wildcard expansion */
    sz_files=INITFILENUMBER;
    files=wmalloc(sizeof(char*)*INITFILENUMBER);
    *files=0;
    current=0;
    
    /* Expand wildcard */
    for (i=0;i<wildidx;i++) {
        expand(wildstring[i]);
        free(wildstring[i]);
    }
    free(wildstring);
    return files;
}
/*
 *
 *      Driver routine for wildcard(and brace) expansion.
 *
 */
char **expand_wildcard(char *str)
{
    char *dummystr[2];
    dummystr[0]=str;
    dummystr[1]=0;
    return expand_wildcards(dummystr);
}
/*
 *  Free the allocated memory.
 *  This routine need not necessarily be called, 
 *  if 'malloc' heap on your machine is rich.
 */

void discard_wildcard(char **f)
{
    char **c;
    c=f;
    while(*c) {
        free(*c);
        c++;
    }
    free(f);
}

#else /* MSDOS*/
#include <stdio.h>
char **expand_wildcard(char *str)
{
    static char *Wild[2];

    Wild[0] = str;
    Wild[1] = NULL;
    return Wild;
}
void discard_wildcard(char **f)
{
    *f = NULL;  /* Dummy */
    return;
}
#endif /* MSDOS*/

#ifdef DEBUG
#include <stdio.h>

void main(int argc, char *argv[])
{
  int i;
  char **f, **g;
  
  for (i = 1; i < argc; i++) {
    f = g = expand_wildcard(argv[i]);
    for (; *f; f++) {
      printf("%s\n", *f);
    }
    discard_wildcard(g);
  }
}
#endif
