/* -*- mode: c; coding: sjis; -*-
 * Copyright 1992-1997, 1999, By T.Furukawa
 *---------------------------------------------------------------
 * $Id: zen2han.c,v 1.12 2006/09/06 11:22:29 tfuruka1 Exp $
 * $Log: zen2han.c,v $
 * Revision 1.12  2006/09/06 11:22:29  tfuruka1
 * rWO擾悤ɕύX܂B
 *
 * Revision 1.11  2006/08/29 12:56:43  tfuruka1
 * obt@TCY𑝂₵܂B
 *
 * Revision 1.10  2006/08/25 16:41:39  tfuruka1
 * VersionRevisiondĂ̂ŏC܂B
 *
 * Revision 1.9  2006/08/25 16:30:56  tfuruka1
 * s1024zꍇŁA1023oCgڂ1oCgڂꍇA
 * ꕶuȂ킩vԂɂȂAZEROXgbp2oCgڂ
 * ďĂ܂AANZXoCI[VĂC
 * ܂BAA1024oCgڂ܂܁A_A_ꍇ͐
 * Ȃ肪cĂ܂B
 *
 * Revision 1.8  1999/12/29 08:27:44  tfuruka1
 * Copyright\̔NԈႦĂ̂ŏCB
 *
 * Revision 1.7  1999/12/29 08:24:38  tfuruka1
 * `t@C1oCgR[h2oCgR[h̕ϊo悤ɕύX
 * B
 *
 * Revision 1.6  1999/12/29 05:06:52  tfuruka1
 * Spp-́|ɕϊ悤ɕύXB
 * Spṕ[́|ɕϊ悤ɕύXB
 *
 * Revision 1.5  1999/12/29 04:26:43  tfuruka1
 * UsagebZ[WɒǉIvV\ĂȂ̂ŁACB
 *
 * Revision 1.4  1999/12/28 18:52:10  tfuruka1
 * -X IvVǉBSpAt@xbgϊȂB
 * -9 IvVǉBSpϊȂB
 *
 * Revision 1.3  1997/04/26 06:04:14  furukawa
 * Stdin/out T|[g
 *
 * Revision 1.2  1997/04/18  14:33:09  furukawa
 * Version  make date \悤ɂ
 *
 * Revision 1.1  1997/04/18  14:20:15  furukawa
 * Initial revision
 *
 */

/* WJ}N */
#define TO_STRING(n) #n
static char Version[] = MAKE_VERSION " ($Name: ARAYASHIMMACHI $)";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "zen2han.h"

#define BUFF_SIZE (8192)

#if !defined(MAX_PTH)
#   define MAX_PATH 255
#endif

static FILE *InFile, *OutFile;

struct {
    char Key[16];
    char DefFile[256];
} DefFile = {"-*-Patch-*-", "zen2han.def"};

/* J^Jĩe[u(pJ^JĩR[hƏԂ킹Ă) */
static char *kanacode = "  BuvAE@BDFHb["
"ACEGIJLNPRTVXZ\^`cegijklmnqtwz}~"
"JK";

/* ̉\̂镶 */
static char *MaruOk = "nqtwz";

/* ̉\̂镶 */
static char *TenOk = "JLNPRTVXZ\^`cegnqtwz";

/* R[h̒ue[u */
PCONVERT_TBL Wtbl = NULL;

int IgnoreCommaAfterSpace = FALSE;
int IgnoreAsciiKanjiSpace = FALSE;
int IgnoreDasheConv = FALSE;
int IgnoreAlphaConv = FALSE;
int IgnoreNumConv = FALSE;
int StdOut = FALSE;
int StdIn = FALSE;

/* 
 * fgetsƓl̋@\ł邪ÁuȂ킩v𔭐Ȃ
 */
char *kfgets(char *buf, int cbMax, FILE *fp)
{
    int i;
    int c;

    for (i = 0; i < cbMax - 2; i ++) {
        if (EOF == (c = getc(fp))) {
            break;
        }
        *(buf + i) = c;
        if (isKanji(c)) {
            i++;
            *(buf + i) = getc(fp);
        }
    }
    *(buf + i) = '\0';
    return 0 == i ? NULL : buf;
}

/* yє̏ */
void Dakuon(unsigned char *from)
{
    unsigned char *to = from;
    int i, j;

    for (i = 0; *(from + i); i++) {
        if (0x80 > *(from + i)) {       /* ASCII */
            *to++ = *(from + i);
            continue;
        }
        if ((2 <= i) && (0 == memcmp("J", from + i, 2))) {
            for (j = 0; TenOk[j]; j += 2) {
                if (0 == memcmp(&TenOk[j], from + i - 2, 2)) {
                    (*(to - 1))++;
                    i++;
                    break;
                }
            }
            if (TenOk[j]) continue;
        }
        if ((2 <= i) && (0 == memcmp("K", from + i, 2))) {
            for (j = 0; MaruOk[j]; j += 2) {
                if (0 == memcmp(&MaruOk[j], from + i - 2, 2)) {
                    (*(to - 1)) += 2;
                    i++;
                    break;
                }
            }
            if (MaruOk[j]) continue;
        }
        *to++ = *(from + i++);
        *to++ = *(from + i);
    }
    *to = '\0';
}

/* 又[` */
void zen2han(unsigned char *from, unsigned char *to)
{
    PCONVERT_TBL Current;
    int i;
    unsigned int wbyte;
    unsigned char wstr[3];
    
    for (i = 0; *(from + i); i++) {
        if (0x80 > *(from + i)) { /* PoCgR[h */
            wstr[0] = *(from + i);
            wstr[1] = '\0';
            for (Current = Wtbl; Current; Current = Current->Next) {
                if (0 == memcmp(Current->from, wstr, strlen(Current->from))) {
                    if (Current->to[0]) {
                        strcpy((char *)to, Current->to);
                        to += strlen(Current->to);
                    }
                    break;
                }
            }
            if (!Current) {
                *to++ = *(from + i);
            }
            continue;
        }
#if defined(SJIS)
        if ((HAN_KANA_CODE <= *(from + i)) &&
            ((HAN_KANA_CODE + 64) > *(from + i))) { /* pJi */
            *to++ = kanacode[(*(from + i) - HAN_KANA_CODE) * 2];
            *to++ = kanacode[(*(from + i) - HAN_KANA_CODE) * 2 + 1];
            continue;
        }
#endif
        wbyte = MakeWbyte(*(from + i), *(from + i + 1));
        wstr[0] = (char)(wbyte >> 8) & 255;
        wstr[1] = (char)wbyte & 255;
        wstr[2] = '\0';
        i++;
        if (!IgnoreAlphaConv) {
            /* p */
            if ((ZEN_A_CODE <= wbyte) && ((ZEN_A_CODE + 26) > wbyte)) {

                *to++ = (char)('A' + wbyte - ZEN_A_CODE);
                continue;
            }
            /* p */
            if ((ZEN_a_CODE <= wbyte) && ((ZEN_a_CODE + 26) > wbyte)) {
                *to++ = (char)('a' + wbyte - ZEN_a_CODE);
                continue;
            }
        }
        if (!IgnoreNumConv) {
            if ((ZEN_ZERO_CODE <= wbyte) &&
                ((ZEN_ZERO_CODE + 10) > wbyte)) { /*  */
                *to++ = (char)('0' + wbyte - ZEN_ZERO_CODE);
                continue;
            }
        }
#if defined(EUC)
        if ((HAN_KANA_CODE <= wbyte) &&
            ((HAN_KANA_CODE + 64) > wbyte)) { /* pJi */
            *to++ = kanacode[(wbyte - HAN_KANA_CODE) * 2];
            *to++ = kanacode[(wbyte - HAN_KANA_CODE) * 2 + 1];
            continue;
        }
#endif
        for (Current = Wtbl; Current; Current = Current->Next) {
            if (0 == memcmp(Current->from, wstr, strlen(Current->from))) {
                if (Current->to[0]) {
                    strcpy((char *)to, Current->to);
                    to += strlen(Current->to);
                }
                break;
            }
        }
        if (Current) continue;
        *to++ = wstr[0];
        *to++ = wstr[1];
    }
    *to = '\0';
}

void PrintOut(unsigned char *Str)
{
    int OldChar = CODE_OTHER;
    
    while (*Str) {
        if (isKanji(*Str)) {     /* R[h */
            if (CODE_ALPHANUM == OldChar){      /* ꕶOp */
                if (!IgnoreDasheConv) {
                    if (0 == memcmp("[", Str, 2)) {
                        fprintf(OutFile, "-");
                        Str += 2;
                        OldChar = CODE_OTHER;
                        continue;
                    }
                }
                if (!IgnoreAsciiKanjiSpace) {
                    fprintf(OutFile, " ");
                }
            }
            if (!IgnoreDasheConv) {
                if (CODE_KANJI == OldChar && 0 == memcmp("|", Str, 2)) {
                    if (isZenKana(MakeWbyte((USHORT)*(Str - 2),
					    (USHORT)*(Str - 1)))) {
                        fprintf(OutFile, "[");
                        Str += 2;
                        OldChar = CODE_KANJI;
                        continue;
                    }
                }
                else if (CODE_KANJI == OldChar && 0 == memcmp("[", Str, 2)) {
                    if (isZenAlphaNum(MakeWbyte((USHORT)*(Str - 2),
                                                (USHORT)*(Str - 1)))) {
                        fprintf(OutFile, "|");
                        Str += 2;
                        OldChar = CODE_KANJI;
                        continue;
                    }
                }
            }
            OldChar = CODE_KANJI;
            fprintf(OutFile, "%c", *Str++);
            fprintf(OutFile, "%c", *Str++);
        }
        else if (isalnum(*Str)) {
            if (!IgnoreAsciiKanjiSpace) {
                if (CODE_KANJI == OldChar){
                    fprintf(OutFile, " ");
                }
            }
            OldChar = CODE_ALPHANUM;
            fprintf(OutFile, "%c", *Str++);
        }
        else if ('\n' == *Str) {
            OldChar = CODE_OTHER;
            fprintf(OutFile, "%c", *Str++);
        }
        else if (',' == *Str) {
            if (' ' == *(Str + 1) || IgnoreCommaAfterSpace) {
                fprintf(OutFile, ",");
            }
            else {
                fprintf(OutFile, ", ");
            }
            Str++;
        }
        else {
            if (!IgnoreDasheConv) {
                if ('-' == *Str && CODE_KANJI == OldChar) {
                    if (isZenKana(MakeWbyte((USHORT)*(Str - 2),
                                            (USHORT)*(Str - 1)))) {
                        fprintf(OutFile, "[");
                        Str++;
                        OldChar = CODE_KANJI;
                        continue;
                    }
                    else if (isZenAlphaNum(MakeWbyte((USHORT)*(Str - 2),
                                                     (USHORT)*(Str - 1)))) {
                        fprintf(OutFile, "|");
                        Str++;
                        OldChar = CODE_KANJI;
                        continue;
                    }
                }
            }
            OldChar = -1;
            if ('\r' != *Str) {
                fprintf(OutFile, "%c", *Str++);
            }
        }
    }
}

static void TitleOut(void)
{
#if defined(DJGPP)
    printf("<<DJGPP ");
#elif defined(MSDOS)
    printf("<<MS-DOS ");
#elif defined(WIN32)
    printf("<<WIN32 ");
#elif defined(UNIX)
    printf("<<UNIX ");
#else
must be -DDJGPP, -DMSDOS, -DWIN32, -DUNIX
#endif

#if defined(EUC)
    printf("EUC Version %s>>\n", Version);
#else
    printf("SHIFT-JIS Version %s>>\n", Version);
#endif

    printf("---------------------------------------------------"
           "--------------------\n"
           "SpAt@j[bN  ASCII CODE\n"
           "pJ^Ji  SpJ^Ji(/ϊ܂)\n"
           "Sp̋  p̋, PC98 r  JIS r\n"
           "'[''|'̓̓~X_ϊ, ̑ϊc[\n\n"
           "Copyright 1992-1997, 1999, 2006 By T.Furukawa"
           " (tfuruka1@nifty.com)\n"
           "---------------------------------------------------"
           "--------------------\n");
    fflush(stdout);
}

static void Usage(char *Command)
{
    TitleOut();

    fprintf(stderr,
            "usage: %s [-9] [-X] [-d] [-a] [-c] [-t<Def>] -s "
            "{filename ...|-}\n",
            Command);
    fprintf(stderr,
            "\t-9\t[O-X]2oCg1oCg֕ϊȂ\n"
            "\t-X\t[`-y-]2oCg1oCg֕ϊȂ\n"
            "\t-d\t'[', '|' ̓̓~X̐_sȂ\n"
            "\t-a\tASCIIƊ̊ԂɃXy[XȂ\n"
            "\t-c\t','(Comma)̎ɃXy[XȂ\n"
            "\t-t<Def>\tSppϊ`t@C Def Ŏw肳ꂽ"
            "t@C\n\t\tgp܂B(<  > ͎ۂɂ͓͂Ȃŉ"
            ")\n"
            "\t-s\tϊʂWo͂֏o͂܂B̃IvVw肳\n"
            "\t\tĂȂꍇ͒ړ̓t@C܂B\n");
    fprintf(stderr,
            "\tfilename\tϊt@Cw肵܂Bt@C̓C\n"
            "\t\thJ[hwo܂Bt@C - w肵ꍇ͕W\n"
            "\t\t͂ǂݍ݂܂B- w肵ꍇ͏o͂Wo͂\n"
            "\t\to͂܂Bt@C - ͓ɂ͎wo܂B\n"
            );
    exit(1);
}

extern char **expand_wildcard(char *);
extern void discard_wildcard(char **);
int main(int argc, char *argv[])
{
    unsigned char *Buf1, *Buf2;
    char NewFileName[MAX_PATH], OldFileName[MAX_PATH], *p, **f, **g;
    int i;

    if (1 == argc) Usage(argv[0]);

    if (NULL == (Buf1 = (unsigned char *)malloc(BUFF_SIZE * 8))) {
        fprintf(stderr, "܂\n");
        return 1;
    }
    Buf2 = Buf1 + BUFF_SIZE;

    if (p = getenv("ZHDEF")) {
        strncpy(DefFile.DefFile, p, 255);
    }

    for (i = 1; i < argc; i++) {
        if ('-' != *argv[i]) break;
        switch(*(argv[i] + 1)) {
        case '9':
            IgnoreNumConv = TRUE;
            break;
        case 'X':
            IgnoreAlphaConv = TRUE;
            break;
        case '\0':
            StdIn = TRUE;
            StdOut = TRUE;
            break;
        case 's':
            StdOut = TRUE;
            break;
        case 'a':
            IgnoreAsciiKanjiSpace = TRUE;
            break;
        case 'c':
            IgnoreCommaAfterSpace = TRUE;
            break;
        case 'd':
            IgnoreDasheConv = TRUE;
            break;
        case 't':
            if ('\0' == *(argv[i] + 2)) {
                fprintf(stderr, "-t IvV̎gp@Ɍ肪܂B\n");
                Usage(argv[0]);
            }
            printf("Sppϊ`t@C <%s> ", DefFile.DefFile);
            strncpy(DefFile.DefFile, argv[i] + 2, 255);
            printf(" <%s> ɕύX܂B\n", DefFile.DefFile);
            break;
        default:
            fprintf(stderr, "unknown option (%s)\n", argv[i]);
            Usage(argv[0]);
        }
    }

    if (NULL  == argv[i] && !StdIn) {
        Usage(argv[0]);
    }

    DefRead(DefFile.DefFile);

    if (StdIn) {
        OutFile = (FILE *)stdout;
        while (kfgets((char *)Buf1, BUFF_SIZE, stdin)) {
            zen2han(Buf1, Buf2);
            Dakuon(Buf2);
            PrintOut(Buf2);
        }
        return 0;
    }
    
    for (; i < argc; i++) {
        f = g = expand_wildcard(argv[i]);
        for (; *f; f++) {
            strcpy(NewFileName, *f);
            strcpy(OldFileName, *f);
            if (!StdOut) {
                if (NULL == (p = strrchr(OldFileName, '.'))) {
                    strcat(OldFileName, ".bak");
                } else {
                    strcpy(p, ".bak");
                }
                if (0 == strcmp(NewFileName, OldFileName)) {
                    fprintf(stderr, "%s ̃t@C͊gq .bak "
                            "Ȃ̂ŏo܂\n", NewFileName);
                    continue;
                }
                unlink(OldFileName);

                if (-1 == rename(NewFileName, OldFileName)) {
                    perror(NewFileName);
                    continue;
                }
                if (NULL == (InFile = fopen(OldFileName, "rt"))) {
                    perror(OldFileName);
                    continue;
                }
                if (NULL == (OutFile = fopen(NewFileName, "wt"))) {
                    perror(NewFileName);
                    fclose(InFile);
                    continue;
                }
                fprintf(stderr, "Now converting %s\n", NewFileName);
            } else {
                if (NULL == (InFile = fopen(OldFileName, "rt"))) {
                    perror(OldFileName);
                    continue;
                }
                OutFile = (FILE *)stdout;
            }
            while (kfgets((char *)Buf1, BUFF_SIZE, InFile)) {
                zen2han(Buf1, Buf2);
                Dakuon(Buf2);
                PrintOut(Buf2);
            }
            fclose(InFile);
            if (!StdOut) fclose(OutFile);
        }
        discard_wildcard(g);
    }
    return 0;
}
