/* -*- mode: C; coding: sjis-dos; -*-
 * Copyright 1992-1997, By T.Furukawa
 *---------------------------------------------------------------
 * $Id: zen2han.h,v 1.3 1999/12/29 05:14:11 tfuruka1 Exp $
 * $Log: zen2han.h,v $
 * Revision 1.3  1999/12/29 05:14:11  tfuruka1
 * SpAt@xbgASp𔻒f}NǉB
 *
 * Revision 1.2  1997/04/18 14:33:09  furukawa
 * Comment add.
 *
 * Revision 1.1  1997/04/18  14:20:39  furukawa
 * Initial revision
 *
*/
typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef unsigned long ULONG;

#ifndef FALSE
#       define  FALSE   0
#       define  TRUE    1
#endif

/* R[h̃`FbNp}N */
#define isKanjiEUC(c)   ((c) >= 0xa1)
#define isKanaEUC(c)    ((c) == 0x8e)
#define isKanjiSJIS(c)  (((c) >= 0x81 && (c) <= 0x9f) ||\
                         ((c) >= 0xe0 && (c) <= 0xfc))
#define isKanaSJIS(c)   ((c) >= 0xa0 && (c) < 0xe0)

#if defined(EUC)
#       define isKanji          isKanjiEUC
#       define isKana           isKanaEUC
#       define ZEN_A_CODE       0xa3c1
#       define ZEN_a_CODE       0xa3e1
#       define ZEN_ZERO_CODE    0xa3b0
#       define HAN_KANA_CODE    0x8ea0
#       define ZEN_S_A_CODE     0xa5a1
#       define ZEN_S_KE_CODE    0xa5f6
#elif defined(SJIS)
#       define isKanji          isKanjiSJIS
#       define isKana           isKanaSJIS
#       define ZEN_A_CODE       (unsigned int)0x8260
#       define ZEN_a_CODE       (unsigned int)0x8281
#       define ZEN_ZERO_CODE    (unsigned int)0x824f
#       define HAN_KANA_CODE    (unsigned int)0xa0
#       define ZEN_S_A_CODE     (unsigned int)0x8340
#       define ZEN_S_KE_CODE    (unsigned int)0x8396
#else
RpCIvV -DEUC, -DSJIS ̉Kw肵ĉ
#endif

#define isZenKana(c)  (((c) >= ZEN_S_A_CODE) && ((c) <= ZEN_S_KE_CODE))
#define isZenAlpha(c) ((((c) >= ZEN_A_CODE) && ((c) <= (ZEN_A_CODE + 26)))||\
                       (((c) >= ZEN_a_CODE) && ((c) <= (ZEN_a_CODE + 26))))
#define isZenNum(c)   (((c) >= ZEN_ZERO_CODE) && ((c) <= (ZEN_ZERO_CODE + 10)))
#define isZenAlphaNum(c) (isZenAlpha(c) || isZenNum(c))

#define CODE_OTHER      -1
#define CODE_ALPHANUM   0
#define CODE_KANJI      1

#define MakeWbyte(Fast, Second) ((Fast << 8) + Second)

typedef struct _WTBL{
    char from[4], to[40];
    struct _WTBL *Next;
} CONVERT_TBL, *PCONVERT_TBL;

void DefRead(char *DefFile);
